Installing Satallax
===================


Requirements
------------

The following command should install all build dependencies of Satallax
on a Debian-based system (tested with Ubuntu 20.04):

    sudo apt install build-essential zlib1g-dev ocamlbuild libnum-ocaml-dev

The last package, `libnum-ocaml-dev`, is only necessary for
newer OCaml versions.

If you're not the administrator of the computer on which you're installing,
you can quote the previous paragraphs to the administrator.


Instructions
------------

To automatically build Satallax and all accompanying tools, i.e.
PicoSAT, MiniSat and E, run

    make

If the following command does not yield any occurrence of the word ERROR,
building Satallax should have worked:

    ./test | grep ERROR

`./satallax.native` is the native code executable.
See `test` for examples of how to use it.


Checking proof terms in Coq
---------------------------

If you have Coq 8.4, then you can check the proof terms generated by Satallax
when the `-c` and `-p` options are used.  To do this, you will need to use the
Coq files in the coq subdirectory. These files can be compiled via

    make coq

