SOLVEDMODES = $(shell cat efixed.solvedmodes)

define setmode =
$(2): \
$(2)/$(firstword $(1))
$(2)/$(firstword $(1)): MODE=$(lastword $(1))
endef

$(foreach sm,$(SOLVEDMODES),$(eval $(call setmode,$(subst @, ,$(sm)),out/tptp72/test/satallax-current/noproofs)))
$(foreach sm,$(SOLVEDMODES),$(eval $(call setmode,$(subst @, ,$(sm)),out/tptp72/test/satallax-current/tstp)))

out/tptp72/test/satallax-current/noproofs/%: ../satallax.native TPTP-v7.2.0/Problems/%
	@mkdir -p "`dirname $@`"
	TPTP=`pwd`/TPTP-v7.2.0 \
	  /usr/bin/time -o "$@.time" $^ \
	  -m $(MODE) > "$@"; \
	  test $$? -eq 10 -o $$? -eq 15 -o $$? -eq 20 -o $$? -eq 25

out/tptp72/test/satallax-current/tstp/%: ../satallax.native TPTP-v7.2.0/Problems/%
	@mkdir -p "`dirname $@`"
	-TPTP=`pwd`/TPTP-v7.2.0 \
	  /usr/bin/time -o "$@.time" $^ \
	  -p tstp -m $(MODE) -t 100 > "$@"; \
	  test $$? -eq 10 -o $$? -eq 15 -o $$? -eq 20 -o $$? -eq 25
