exception InputHelpError of string

val problemfile : string ref

val slave : bool ref
val slaveargs : string list ref
val preparsed : bool ref

val mode : string list ref
val schedule_files : string list ref
val flag_overrides : (string * string) list ref

val timeout : float option ref
val hardtimeout : float option ref
val max_searchoptions : int option ref

val completep : bool ref
val nontheorem : bool ref

type proofkind = TSTP | CoqScript | CoqSPfTerm | Dedukti | HOCore | Model | ModelTrue | IsarScript | PfInfo | PfUseful | PfFormdeps
val mkproofterm : proofkind option ref
val mkprooftermp : unit -> bool
val pfusefulout : string option ref
val pfformdepsout : string option ref
val proofoutfile : string option ref

val verbosity : int ref

val printnumaxiomsflag : bool ref
val selectaxiomsflag : bool ref
val select_axioms_list : int list ref
val foffiles : bool ref

val recognize_hashroots : bool ref

val help_lines : string list
val process_command_line_args : string list -> unit

