(* File: clauses.mli *)
(* Author: Chad E Brown *)
(* Created: October 2010 *)

open Term
open Refut

val clauses : clause list ref

val assumption_lit : (int, trm * trm) Hashtbl.t

val processed : (trm, int) Hashtbl.t

val clause_ruleinfo : (clause,ruleinfo) Hashtbl.t ref

val allclauses : clause list ref (* allclauses is only used if formdeps is activated, in which case someone wants useless information. it contains all the clauses that were used in all searches across different subgoals. Aug 2016 *)
val allclause_ruleinfo : (clause,ruleinfo) Hashtbl.t ref

val new_assumption_lit : int -> unit
val new_search_clause : clause -> ruleinfo option -> unit

val reset : unit -> unit
