open Term

let choice_axioms x a =
  let ao = Ar(a,Prop) in

  (* forall y : a -> Prop. forall z : a. (y z -> y (x y)) *)
  (* (x : (a -> Prop) -> a) *)
  let m1 = Ap (Forall (ao),Lam (ao,Ap (Forall a,Lam (a,Ap (Ap (Imp, Ap (DB (1, ao), DB (0, a))),
  	 Ap (DB (1, ao),Ap (Name (x, Ar (ao, a)), DB (1, ao)))))))) in

  let m2 = Ap (Forall (ao),Lam (ao,Ap(Ap (Imp,Ap(Ap (Imp,Ap (Forall a,Lam (a,
  	Ap (Ap (Imp, Ap (DB (1, ao), DB (0, a))),False)))),False)),Ap (DB (0, ao),
  	Ap (Name (x, Ar (ao, a)),DB (0, ao)))))) in

  let m3 = Ap (Forall (ao),Lam (ao,Ap(Ap (Imp,Ap (Exists a,Lam (a,
  	Ap (DB (1, ao), DB (0, a))))),Ap (DB (0, ao),
  	Ap (Name (x, Ar (ao, a)),DB (0, ao)))))) in

  [m1; m2; m3]

(** Input: Name x, Type a, association list (term -> hypothesis name) hyp 
	Output: name of the hypothesis that defines x as a choice operator **)
let get_Choicop_axiom x a hyp = 
  let ms = choice_axioms x a in
  try
    let (m,h) = List.find (fun (m,h) -> List.exists ((=) m) ms) hyp in h
  with Not_found -> "missing_choice_axiom_for" ^ x
