open Preterm
open Term

val coq : bool ref
val translucent_defns : bool ref

type probitem =
  | ProbDef of string * stp * trm * (string * string) list * float
  | ProbAx of string * string * trm * (string * string) list * float
  | ProbConj of string * trm * (string * string) list * float
val probitem_weight : probitem -> float
val probsig : probitem list ref
val init_probitem : probitem -> unit

val conjecturename : string ref
val conjecture : (trm * trm) option ref
val part_of_conjecture : (trm,unit) Hashtbl.t

val coqsig_base : string list ref
val coqsig_const : (string * stp) list ref
val coqsig_def : (string * trm) list ref
val coqsig_hyp : (string * trm) list ref

val name_base : (string,unit) Hashtbl.t
val name_base_list : string list ref
val name_tp : (string,stp) Hashtbl.t
val name_trm : (string,(trm * stp) * bool ref) Hashtbl.t
val name_trm_list : (string * trm * stp) list ref
val name_def : (string,trm) Hashtbl.t
val name_def_all : (string,trm) Hashtbl.t
val name_def_prenorm : (string,trm) Hashtbl.t
val name_hyp : (string,trm) Hashtbl.t
val name_hyp_inv : (trm,string * trm) Hashtbl.t

val initial_branch : trm list ref
val initial_branch_prenorm : trm list ref

val set_default_elt : string -> trm -> unit
val set_default_elt_if_needed : stp -> trm -> unit
val default_elt : string -> trm
val default_elt_p : string -> bool

val get_fresh_name : stp -> string * trm

val declare_base_type : string -> unit
val declare_name_type : string -> stp -> unit
val declare_typed_constant : string -> string -> pretrm -> (string * string) list -> unit
val declare_definition : string -> string -> pretrm -> (string * string) list -> unit
val declare_thf_logic_formula : string -> string -> pretrm -> (string * string) list -> unit

val coqnorm : trm -> trm
val normalize : trm -> trm
val partialnormalize : trm -> trm
